#include "orxonox_gui.h"

int main( int argc, char *argv[] )
  {
    gtk_init (&argc, &argv);
    Window* orxonoxGUI = new Window("Graphical Orxonox Launcher");
    orxonoxGUI->connectSignal ("destroy", orxonoxGUI->orxonox_gui_quit);
    orxonoxGUI->connectSignal ("delete_event", orxonoxGUI->orxonox_gui_quit);

    Frame* Frametest = new Frame ("Test");
    orxonoxGUI->fill((Frame*) Frametest);
    Box* box = new Box ('v');
    Frametest->fill(box);

    CheckButton* button = new CheckButton("test");
    button->connectSignal ("clicked", orxonoxGUI->orxonox_gui_quit);
    box->fill(button);
    Slider* slider = new Slider("testslider", 0, 100);
    box->fill(slider);

    orxonoxGUI->showall ();

    gtk_main();
    return 0;
  }


/* WIDGET */
void Widget::show()
{
  gtk_widget_show (widget);
}

void Widget::connectSignal (char* event, gint ( *signal)( GtkWidget*, GdkEvent*, void *))
{
  g_signal_connect (G_OBJECT (this->widget), event, G_CALLBACK (signal), NULL);
}

/* CONTAINERS*/

void Container::fill (Widget *lowerWidget)
{
  gtk_container_add (GTK_CONTAINER(this->widget), lowerWidget->widget);
  this->down = lowerWidget;
}

// gtk_container_set_border_width (GTK_CONTAINER (widget), 5);

/* WINDOW */

Window::Window (void)
{
  widget = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_window_set_policy(GTK_WINDOW(widget), TRUE, TRUE, TRUE);
}

Window::Window (char* windowName)
{
  widget = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_window_set_policy(GTK_WINDOW(widget), TRUE, TRUE, TRUE);
  this->setTitle(windowName);
}

Window::~Window ()
{}

void Window::showall ()
{
  gtk_widget_show_all  (widget);
}

void Window::setTitle (char* title)
{
  gtk_window_set_title (GTK_WINDOW (widget), title);
}


gint Window::orxonox_gui_quit ( GtkWidget *widget, GdkEvent *event, gpointer data)
{
  gtk_main_quit();
  return FALSE;
}


/* FRAME */

Frame::Frame (void)
{
  widget = gtk_frame_new ("");
}
Frame::Frame (char* title)
{
  widget = gtk_frame_new (title);
}
Frame::~Frame ()
{}

void Frame::setTitle (char* title)
{
  gtk_frame_set_label (GTK_FRAME (widget), title);
}



/* BOX */

Box::Box (void)
{
  widget = gtk_hbox_new(FALSE, 0);
}
Box::Box (char boxtype)
{
  if (boxtype == 'v')
    {
      widget = gtk_vbox_new(FALSE, 0);
    }
  else
    {
      widget = gtk_hbox_new(FALSE, 0);
    }
}

Box::~Box ()
{}

void Box::fill (Widget *lowerWidget)
{
  gtk_box_pack_start (GTK_BOX(this->widget), lowerWidget->widget, TRUE, TRUE, 0);
}


/* OPTION */

/* BUTTON */
Button::Button(char* buttonname)
{
  widget = gtk_button_new_with_label(buttonname);
}

/* CHECKBUTTON */
CheckButton::CheckButton(char* buttonname)
{
  widget = gtk_check_button_new_with_label(buttonname);
}

/* SLIDER */
Slider::Slider (char * slidername,int start, int end)
{
  widget = gtk_hscale_new_with_range (start, end, 5);
}
