#ifndef _ORXONOX_GUI_H
#define _ORXONOX_GUI_H

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <gtk/gtkmain.h>
#include <gtk/gtkwindow.h>
#include <gtk/gtkframe.h>
#include <gtk/gtkhbox.h>
#include <gtk/gtkvbox.h>
#include <gtk/gtkbutton.h>
#include <gtk/gtkcheckbutton.h>
#include <gtk/gtkhscale.h>



class Widget
{
 public:
  Widget* next;
  GtkWidget* widget;  

  //virtual void create ();
  //  void addWidget ();
   void connectSignal (char* event, gint (*signal)(GtkWidget*, GdkEvent*,  void *));
   void show ();
};



class Container : public Widget
{
 private:
  int borderwidth;
  int policy;
  char* label;
  
 public:
  Widget* down;
  void setBorderWidth (int borderwidth);
  virtual void setTitle (char* title) = 0;
  void fill (Widget *lowerWidget);
};

class Window : public Container
{
 public:
  Window (char* windowName);
  Window (void);
  ~Window ();
  
  void setTitle (char* title);
  void showall ();
  static gint orxonox_gui_quit ( GtkWidget *widget, GdkEvent *event, gpointer data);
};

class Frame :public Container
{
 public:
  Frame (char* frameName);
  Frame (void);
  ~Frame ();
  
  void setTitle (char* title);
};

class Box : public Widget
{
 public:
  Box (void);
  Box (char boxtype);
  ~Box (void);

  void fill (Widget *lowerWidget);

};

class Option : public Widget
{
};

class Button : public Option
{
 public:
  Button (char* buttonname);
  ~Button (void);
};

class CheckButton : public Option
{
 public:
  CheckButton (char* buttonname);
  ~CheckButton (void);
};

class Slider : public Option
{
 public:
  Slider (char * slidername,int start, int end);
  ~Slider();
};
//gint orxonox_gui_quit ( GtkWidget *widget, GdkEvent *event, gpointer data);

#endif /* _ORXONOX_GUI_H */
